<?php
/*
Plugin Name: Bp Code Snippets
Plugin URI: http://imath.owni.fr/2010/07/10/bp-code-snippets/
Description: Component to share code snippets in buddypress groups
Version: 1.3
Requires at least: WordPress 3.0 / BuddyPress 1.2
Tested up to: WordPress 3.0.1 / BuddyPress 1.2.5
License: GNU/GPL 2
Author: imath
Author URI: http://imath.owni.fr/
Network: true
*/


define( 'BP_CS_SLUG', 'snippets' );
define ( 'BP_CS_PLUGIN_NAME', 'bp-code-snippets' );
define ( 'BP_CS_PLUGIN_URL', WP_PLUGIN_URL . '/' . BP_CS_PLUGIN_NAME );
define ( 'BP_CS_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . BP_CS_PLUGIN_NAME );
define ( 'BP_CS_VERSION', '1.3' );

function bp_code_snippets_init() {
	class Bp_Code_Snippets extends BP_Group_Extension {	

		var $visibility  = 'public';
		var $enable_create_step  = true;
		var $enable_nav_item  = true;
		var $enable_edit_item = true;
		
		function bp_code_snippets() {
			global $bp;
			$this->name = sprintf( __( 'Snippets (%d)', 'bp-code-snippets' ), bp_code_snippets_info_current_group($bp->groups->current_group->id) );
			$this->slug = 'snippets';
			$this->create_step_position = 21;
			$this->nav_item_position = 31;
			$this->enable_nav_item = $this->enable_nav_item();
		}

		function create_screen() {
			if ( !bp_is_group_creation_step( $this->slug ) )
				return false;
			?>

			<h2><?php echo attribute_escape( $this->name ) ?> <?php _e('settings for this group.','bp-code-snippets');?></h2>

			<p><?php _e('Activate the codes category for your group (leave all unchecked if you do not want to use Snippets)','bp-code-snippets');?> :</p>
			<ul>
				<li><input type="checkbox" name="cs_Php" value="php">&nbsp;Php</li>
				<li><input type="checkbox" name="cs_Javascript" value="js">&nbsp;Javascript</li>
				<li><input type="checkbox" name="cs_Css" value="css">&nbsp;Css</li>
				<li><input type="checkbox" name="cs_Xml-Html" value="xml">&nbsp;Xml-Html</li>
				<li><input type="checkbox" name="cs_Sql" value="sql">&nbsp;Sql</li>
				<li><input type="checkbox" name="cs_Actionscript" value="as3">&nbsp;Actionscript</li>
				<li><input type="checkbox" name="cs_Java" value="java">&nbsp;Java</li>
				<li><input type="checkbox" name="cs_JavaFX" value="jfx">&nbsp;JavaFX</li>
				<li><input type="checkbox" name="cs_Perl" value="pl">&nbsp;Perl</li>
				<li><input type="checkbox" name="cs_Python" value="py">&nbsp;Python</li>
				<li><input type="checkbox" name="cs_Ruby" value="ruby">&nbsp;Ruby</li>
				<li><input type="checkbox" name="cs_ColdFusion" value="cf">&nbsp;ColdFusion</li>
				<li><input type="checkbox" name="cs_AppleScript" value="applescript">&nbsp;AppleScript</li>
				<li><input type="checkbox" name="cs_Cpp" value="cpp">&nbsp;Cpp</li>
				<li><input type="checkbox" name="cs_Csharp" value="csharp">&nbsp;Csharp</li>
				<li><input type="checkbox" name="cs_VB" value="vb">&nbsp;VB</li>
				<li><input type="checkbox" name="cs_Bash" value="bash">&nbsp;Bash</li>
			</ul>

			<?php
			wp_nonce_field( 'groups_create_save_' . $this->slug );
		}

		function create_screen_save() {
			global $bp;

			check_admin_referer( 'groups_create_save_' . $this->slug );

			/* Save any details submitted here */
			$cs_languages="";
			foreach($_POST as $cs_key => $cs_value){
				if(ereg("cs_", $cs_key)){
					$cs_languages.=substr($cs_key,3,strlen($cs_key)-1).":".$cs_value."|";
				}	
			}
			$cs_languages = substr($cs_languages,0,-1);
			if(strlen($cs_languages)>1){
			groups_update_groupmeta($bp->groups->new_group_id, 'snippets_code_ok', $cs_languages);
			}
		}

		function edit_screen() {
			if ( !bp_is_group_admin_screen( $this->slug ) )
						return false; ?>

					<h2><?php echo attribute_escape( $this->name ) ?> <?php _e('settings for this group.','bp-code-snippets');?></h2>

					<p><?php _e('Activate the codes category for your group (leave all unchecked if you do not want to use Snippets)','bp-code-snippets');?> :</p>
					<ul>
						<li><input type="checkbox" name="cs_Php" value="php" <?php echo bp_code_snippets_custom_settings('php',0);?>>&nbsp;Php</li>
						<li><input type="checkbox" name="cs_Javascript" value="js" <?php echo bp_code_snippets_custom_settings('js',0);?>>&nbsp;Javascript</li>
						<li><input type="checkbox" name="cs_Css" value="css" <?php echo bp_code_snippets_custom_settings('css',0);?>>&nbsp;Css</li>
						<li><input type="checkbox" name="cs_Xml-Html" value="xml" <?php echo bp_code_snippets_custom_settings('xml',0);?>>&nbsp;Xml</li>
						<li><input type="checkbox" name="cs_Sql" value="sql" <?php echo bp_code_snippets_custom_settings('sql',0);?>>&nbsp;Sql</li>
						<li><input type="checkbox" name="cs_Actionscript" value="as3" <?php echo bp_code_snippets_custom_settings('as3',0);?>>&nbsp;Actionscript</li>
						<li><input type="checkbox" name="cs_Java" value="java" <?php echo bp_code_snippets_custom_settings('java',0);?>>&nbsp;Java</li>
						<li><input type="checkbox" name="cs_JavaFX" value="jfx" <?php echo bp_code_snippets_custom_settings('jfx',0);?>>&nbsp;JavaFX</li>
						<li><input type="checkbox" name="cs_Perl" value="pl" <?php echo bp_code_snippets_custom_settings('pl',0);?>>&nbsp;Perl</li>
						<li><input type="checkbox" name="cs_Python" value="py" <?php echo bp_code_snippets_custom_settings('py',0);?>>&nbsp;Python</li>
						<li><input type="checkbox" name="cs_Ruby" value="ruby" <?php echo bp_code_snippets_custom_settings('ruby',0);?>>&nbsp;Ruby</li>
						<li><input type="checkbox" name="cs_ColdFusion" value="cf" <?php echo bp_code_snippets_custom_settings('cf',0);?>>&nbsp;ColdFusion</li>
						<li><input type="checkbox" name="cs_AppleScript" value="applescript" <?php echo bp_code_snippets_custom_settings('applescript',0);?>>&nbsp;AppleScript</li>
						<li><input type="checkbox" name="cs_Cpp" value="cpp" <?php echo bp_code_snippets_custom_settings('cpp',0);?>>&nbsp;Cpp</li>
						<li><input type="checkbox" name="cs_Csharp" value="csharp" <?php echo bp_code_snippets_custom_settings('csharp',0);?>>&nbsp;Csharp</li>
						<li><input type="checkbox" name="cs_VB" value="vb" <?php echo bp_code_snippets_custom_settings('vb',0);?>>&nbsp;VB</li>
						<li><input type="checkbox" name="cs_Bash" value="bash" <?php echo bp_code_snippets_custom_settings('bash',0);?>>&nbsp;Bash</li>
					</ul>
					<input type="submit" name="save" value="<?php _e('Save','bp-code-snippets');?>" />

					<?php
					wp_nonce_field( 'groups_edit_save_' . $this->slug );
		}

		function edit_screen_save() {
			global $bp;

			if ( !isset( $_POST['save'] ) )
				return false;

			check_admin_referer( 'groups_edit_save_' . $this->slug );

			/* Insert your edit screen save code here */
			$cs_languages="";
			foreach($_POST as $cs_key => $cs_value){
				if(ereg("cs_", $cs_key)){
					$cs_languages.=substr($cs_key,3,strlen($cs_key)-1).":".$cs_value."|";
				}	
			}
			$cs_languages = substr($cs_languages,0,-1);
			if(strlen($cs_languages)<1){
				$success = groups_update_groupmeta( $bp->groups->current_group->id, 'snippets_code_ok', 0 );
			}
			elseif(groups_get_groupmeta($bp->groups->current_group->id, 'snippets_code_ok')==$cs_languages){
				$success = true;
			}
			else $success = groups_update_groupmeta( $bp->groups->current_group->id, 'snippets_code_ok', $cs_languages );
			

			/* To post an error/success message to the screen, use the following */
			if ( !$success )
				bp_core_add_message( __( 'There was an error saving, please try again', 'bp-code-snippets' ), 'error' );
			else
				bp_core_add_message( __( 'Settings saved successfully', 'bp-code-snippets' ) );

			bp_core_redirect( bp_get_group_permalink( $bp->groups->current_group ) . '/admin/' . $this->slug );
		}

		function display() {
			global $bp;
			$current_url = $bp->root_domain."/".$bp->current_component."/".$bp->current_item."/".$bp->current_action."/";
			?>
			<div class="item-list-tabs no-ajax" id="subnav">
				<ul>
					<?php if(!$bp->action_variables):?>
					<li id="li_rss_code" class="feed"><a href="<?php bp_group_bp_code_snippets_feed_link($bp->action_variables) ?>" title="<?php _e( 'RSS Feed', 'bp-code-snippets');?>''"><?php _e( 'RSS', 'buddypress' ) ?></a></li>
					<?php elseif($bp->action_variables[0]=="single"):?>
						<li id="li_rss_code" class="feed"><a href="<?php bp_group_bp_code_snippets_feed_link($bp->action_variables) ?>" title="<?php _e( 'Comments Feed', 'bp-code-snippets');?>"><?php _e( 'RSS', 'buddypress' ) ?></a></li>
					<?php endif;?>
					<?php if($bp->action_variables[0]=="add"):?>
						<li id="li_list_code"><a href="<?php echo $current_url;?>"><?php _e( 'List of Snippets' , 'bp-code-snippets');?></a></li>
						<li id="li_add_code"  class="current"><a href="<?php echo $current_url;?>add/"><?php _e( 'Add a Snippet' , 'bp-code-snippets');?></a></li>
					<?php else:?>
						<li id="li_list_code" class="current"><a href="<?php echo $current_url;?>"><?php _e( 'List of Snippets' , 'bp-code-snippets');?></a></li>
						<li id="li_add_code"><a href="<?php echo $current_url;?>add/"><?php _e( 'Add a Snippet' , 'bp-code-snippets');?></a></li>
					<?php endif;?>
				</ul>
			</div>
			<?php
 			if($bp->action_variables[0]=="add"){
				require( dirname( __FILE__ ) . '/add-code-snippets.php' );
			}
			elseif($bp->action_variables[0]=="single"){
				require( dirname( __FILE__ ) . '/single-code-snippets.php' );
			}
			elseif($bp->action_variables[0]=="edit"){
				require( dirname( __FILE__ ) . '/edit-code-snippets.php' );
			}
			else{
				require( dirname( __FILE__ ) . '/list-code-snippets.php' );
			}
		}

		function widget_display() {
			global $bp;
			$add_snippet_url = $bp->root_domain."/".$bp->current_component."/".$bp->current_item."/".$this->slug."/add/";
			?>
			<?php if ( groups_get_groupmeta( $bp->groups->current_group->id, 'snippets_code_ok' ) ):?>
			<div class="info-group">
						<h3><?php echo attribute_escape( $this->name ) ?></h3>
						<p><?php printf( __( 'So far %d snippet(s) in this group', 'bp-code-snippets' ), bp_code_snippets_info_current_group($bp->groups->current_group->id) ); ?>, <a href="<?php echo $add_snippet_url; ?>" title="<?php _e('Add yours','bp-code-snippets');?>"><?php _e('Add yours','bp-code-snippets');?></a>!</p>
						<h4><?php _e('Featured Members','bp-code-snippets');?></h4>
						<ul>
							<?php bp_code_snippets_featured_member_snippets($bp->groups->current_group->id, "snippets");?>
							<?php bp_code_snippets_featured_member_snippets($bp->groups->current_group->id, "comments");?>
						</ul>
						<p>&nbsp;</p>
			</div>
			<?php endif;?>
			<?php
		}
		function enable_nav_item() {
			global $bp;

			/* enable the nav item if code category has been selected */
			if ( groups_get_groupmeta( $bp->groups->current_group->id, 'snippets_code_ok' ) )
				return true;
			else
				return false;
		}
	}
	if(get_option( 'cs-enable' )){
		bp_register_group_extension( 'Bp_Code_Snippets' );
	}
}
add_action( 'bp_init', 'bp_code_snippets_init' );

/**
* bp_code_snippets_action_group_feed
* Registers the template for the snippets public directory rss feed
* 
*/
function bp_code_snippets_action_group_feed() {
	global $bp, $wp_query;
	if ( $bp->current_component=='groups' && $bp->current_action=="snippets" && $bp->action_variables[0] == 'feed' ){
		$wp_query->is_404 = false;
		status_header( 200 );

		include_once( 'feeds/group-snippets.php' );
		die();
	}
	elseif($bp->current_component=='groups' && $bp->current_action=="snippets" && $bp->action_variables[0] == 'single' && $bp->action_variables[2]=="feed"){
		$wp_query->is_404 = false;
		status_header( 200 );

		include_once( 'feeds/comments-snippets.php' );
		die();
	}
}
add_action( 'bp_init', 'bp_code_snippets_action_group_feed', 7 );

function bp_group_bp_code_snippets_feed_link($action){
	echo bp_get_group_bp_code_snippets_feed_link($action);
}
	function bp_get_group_bp_code_snippets_feed_link($action) {
		global $bp;
		if(!$action){
			return apply_filters( 'bp_group_bp_code_snippets_feed_link', site_url( $bp->current_component.'/'.$bp->current_item.'/'.$bp->snippets->slug . '/feed' ) );
		}
		elseif($action[0]=="single"){
			return apply_filters( 'bp_group_bp_code_snippets_feed_link', site_url( $bp->current_component.'/'.$bp->current_item.'/'.$bp->snippets->slug .'/'. $action[0] .'/'. $action[1] .'/feed' ) );
		}
	}

/**
* bp_code_snippets_info_current_group
* returns number of snippets for a given group.
* 
*/
function bp_code_snippets_info_current_group($groupid){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$num_snippets = $wpdb->get_var("SELECT count(*) as nbre FROM ".$table_cs." WHERE id_group='$groupid'");
	return $num_snippets;
}

function bp_code_snippets_featured_member_snippets($groupid, $type="snippets"){
	global $wpdb;
	$table_cs_comments = $wpdb->base_prefix.'code_snippets_comments';
	$table_cs = $wpdb->base_prefix.'code_snippets';
	if($type=="comments"){
		$featured_snippets = $wpdb->get_row("SELECT id_user,count(id_cs_comment) as nbre FROM ".$table_cs." LEFT JOIN ".$table_cs_comments." ON (".$table_cs.".id_cs = ".$table_cs_comments.".cs_id) WHERE id_group='$groupid' GROUP BY id_user ORDER BY nbre DESC LIMIT 1");
	}else{
		$featured_snippets = $wpdb->get_row("SELECT id_user,count(*) as nbre FROM ".$table_cs." WHERE id_group='$groupid' GROUP BY id_user ORDER BY nbre DESC LIMIT 1");
	}
	if($featured_snippets->nbre > 0){
		$user_info = get_userdata($featured_snippets->id_user);
		?>
		<li><a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" title="<?php echo $user_info->user_nicename;?>" rel="nofollow">
		<?php echo bp_core_fetch_avatar('item_id=' . $featured_snippets->id_user . '&type=full&width=24&height=24' ) ?>
		</a>&nbsp;<span class="activity">
					<?php if($type=="comments"):?>
						<?php printf( __( '%d comment(s)', 'bp-code-snippets' ), $featured_snippets->nbre ) ?>
					<?php else:?>
						<?php printf( __( '%d snippet(s)', 'bp-code-snippets' ), $featured_snippets->nbre ) ?>
					<?php endif;?>
				  </span></li>
		<?php
	}
}

/**
* bp_code_snippet_get_infos_goup
* retrieves infos about a group (such as his status!).
* 
*/
function bp_code_snippet_get_infos_goup($goup_id){
	global $wpdb;
	$table_group = $wpdb->base_prefix.'bp_groups';
	$infos_group = $wpdb->get_row("SELECT * FROM ".$table_group." WHERE id='$goup_id'");
	return $infos_group;
}

/**
* bp_code_snippets_num_active_user
* Display number of snippets for a user or for all or for a category of code or for a given search
* 
*/
function bp_code_snippets_num_active_user($user_id=0, $request="", $search=""){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$table_group = $wpdb->base_prefix.'bp_groups';
	if($user_id==0){
		$compreq = "";
		if($request!=""){
			$compreq = "AND snippet_type='".$request."'";
		}
		elseif($search!=""){
			$compreq = "AND (snippet_title LIKE '%".$search."%' OR snippet_purpose LIKE '%".$search."%' OR snippet_content LIKE '%".$search."%')";
		}
		$num_user_snippets = $wpdb->get_var("SELECT COUNT(".$table_cs.".id_cs) as nbre FROM ".$table_cs." LEFT JOIN ".$table_group." ON(".$table_cs.".id_group = ".$table_group.".id) WHERE ".$table_group.".status='public' ".$compreq);
	}
	else{
		$num_user_snippets = $wpdb->get_var("SELECT COUNT(*) as nbre FROM ".$table_cs." WHERE id_user='$user_id'");
	}
	return $num_user_snippets;
}

/**
 * bp_code_snippets_load_template_filter
 * This will allow users to override these templates in their active theme and
 * replace the ones that are stored in the plugin directory.
 */
function bp_code_snippets_load_template_filter( $found_template, $templates ) {
	global $bp;

	/**
	 * Only filter the template location when we're on the bp code snippets component pages.
	 */
	if ( $bp->current_component != BP_CS_SLUG )
		return $found_template;

	foreach ( (array) $templates as $template ) {
		if ( file_exists( STYLESHEETPATH . '/' . $template ) )
			$filtered_templates[] = STYLESHEETPATH . '/' . $template;
		else
			$filtered_templates[] = dirname( __FILE__ ) . '/templates/' . $template;
	}

	$found_template = $filtered_templates[0];

	return apply_filters( 'bp_code_snippets_load_template_filter', $found_template );
}
add_filter( 'bp_located_template', 'bp_code_snippets_load_template_filter', 10, 2 );

//Adds member navigation for code snippets if Admin is ok with that!
if(get_option('cs-ma-enable')){
	require ( dirname( __FILE__ ) . '/member-code-snippets.php' );
}

//widget
require ( dirname( __FILE__ ) . '/widget-code-snippets.php' );

//rss
require ( dirname( __FILE__ ) . '/rss-code-snippets.php' );

//add to regular post
if(function_exists(get_blog_option)){
	if(get_blog_option('1','cs-ep-enable')) require ( dirname( __FILE__ ) . '/bp-cs-addtopost.php' );
}
else{
	if(get_option('cs-ep-enable')) require ( dirname( __FILE__ ) . '/bp-cs-addtopost.php' );
}
// add to forum
if(get_option('cs-ef-enable')){
	require ( dirname( __FILE__ ) . '/bp-cs-forum.php' );
}

/**
 * bp_code_snippets_setup_root_component
 * Set up root component
 */
function bp_code_snippets_setup_root_component() {
	// Register 'bp-code-snippets' as a root component
	bp_core_add_root_component( BP_CS_SLUG );
}

/**
 * bp_code_snippets_setup_globals
 * Set up globals
 */
function bp_code_snippets_setup_globals() {
	global $bp, $wpdb;

	/* For internal identification */
	$bp->snippets->id = 'snippets';
	$bp->snippets->slug = BP_CS_SLUG;
	$bp->snippets->table_name_snippets = $wpdb->base_prefix . 'code_snippets';
	$bp->snippets->table_name_comments = $wpdb->base_prefix . 'code_snippets_comments';

	/* Register this in the active components array */
	$bp->active_components[$bp->snippets->slug] = $bp->snippets->id;

	$bp->snippets->forbidden_names = apply_filters( 'bp_snippets_forbidden_names', array( 'snippets', 'my-snippets', 'listing', 'create', 'delete', 'add', 'edit', 'popular', 'most-commented', 'latest', 'active', 'newest', 'all', 'submit', 'feed' ) );

}
add_action( 'bp_setup_root_components', 'bp_code_snippets_setup_root_component' );
add_action( 'bp_setup_globals', 'bp_code_snippets_setup_globals' );

//Main Directory if Admin is ok with that!
if(get_option('cs-homenav-enable')){
require ( dirname( __FILE__ ) . '/home-code-snippets.php' );
}

/**
* bp_code_snippets_load_textdomain
* translation!
* 
*/
function bp_code_snippets_load_textdomain() {

	// try to get locale
	$locale = apply_filters( 'bp_code_snippets_load_textdomain_get_locale', get_locale() );

	// if we found a locale, try to load .mo file
	if ( !empty( $locale ) ) {
		// default .mo file path
		$mofile_default = sprintf( '%s/languages/%s-%s.mo', BP_CS_PLUGIN_DIR, BP_CS_PLUGIN_NAME, $locale );
		// final filtered file path
		$mofile = apply_filters( 'bp_code_snippets_load_textdomain_mofile', $mofile_default );
		// make sure file exists, and load it
		if ( file_exists( $mofile ) ) {
			load_textdomain( BP_CS_PLUGIN_NAME, $mofile );
		}
	}
}
add_action ( 'bp_init', 'bp_code_snippets_load_textdomain', 2 );

/**
* bp_code_snippets_custom_settings
* returns checked if code is in group snippets_code_ok meta
* 
*/
function bp_code_snippets_custom_settings($code, $html=0){
	global $bp;
	$check="";
	$allowed_codes = explode("|",groups_get_groupmeta($bp->groups->current_group->id, 'snippets_code_ok'));
	if($html==0){
		foreach($allowed_codes as $cs){
			if(ereg($code, $cs)){
				$check="checked";
			}
		}
	}
	elseif($html==1){
		foreach($allowed_codes as $cs){
			$keyvalue = explode(':',$cs);
			if($code==$keyvalue[1]){
				$check.='<option value="'.$keyvalue[1].'" selected>'.$keyvalue[0].'</option>';
			}
			else{
				$check.='<option value="'.$keyvalue[1].'">'.$keyvalue[0].'</option>';
			}
		}
	}
	
	return $check;
}

/**
* bp_code_snippets_single_code
* Display a snippet or tells what highlighter library to load.
* 
*/
function bp_code_snippets_single_code($id_snippet, $t_query=1){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	if($t_query==1){
		$single_snippet = $wpdb->get_row("SELECT * FROM ".$table_cs." WHERE id_cs='$id_snippet'");
	}
	elseif($t_query==0){
		$single_snippet = $wpdb->get_var("SELECT snippet_type FROM ".$table_cs." WHERE id_cs='$id_snippet'");
	}
	return $single_snippet;
}


/**
 * bp_code_snippets_record_group_activity
 * Record an activity when a snippet is added
 *
 */
function bp_code_snippets_record_group_activity( $args = '' ) {
	global $bp;

	if ( !function_exists( 'bp_activity_add' ) )
		return false;

	$defaults = array(
		'id' => false,
		'user_id' => $bp->loggedin_user->id,
		'action' => '',
		'content' => '',
		'primary_link' => '',
		'component' => 'groups',
		'type' => false,
		'item_id' => false,
		'secondary_item_id' => false,
		'recorded_time' => gmdate( "Y-m-d H:i:s" ),
		'hide_sitewide' => true
	);
	
	$r = wp_parse_args( $args, $defaults );
	extract( $r );

	return bp_activity_add( array( 'id' => $id, 'user_id' => $user_id, 'action' => $action, 'content' => $content, 'primary_link' => $primary_link, 'component' => $component, 'type' => $type, 'item_id' => $item_id, 'secondary_item_id' => $secondary_item_id, 'recorded_time' => $recorded_time, 'hide_sitewide' => $hide_sitewide ) );
}

function bp_code_snippets_load_post_js($type){
	$liste_js = array("php"=>"shBrushPhp", "js"=>"shBrushJscript", "css"=>"shBrushCss", "as3"=>"shBrushAS3", "sql"=>"shBrushSql", "xml"=>"shBrushXml", "java"=>"shBrushJava", "jfx"=>"shBrushJavaFX", "pl"=>"shBrushPerl", "py"=>"shBrushPython", "ruby"=>"shBrushRuby", "cf"=>"shBrushColdFusion", "applescript"=>"shBrushAppleScript", "cpp"=>"shBrushCpp", "csharp"=>"shBrushCSharp", "vb"=>"shBrushVb", "bash"=>"shBrushBash");
	return $liste_js[$type];
}

/**
 * bp_code_snippets_add_js
 * load the js and css needed
 *
 */
function bp_code_snippets_add_js() {
	global $bp;
	$theme_activated = get_option( 'cs-setting-theme' );
	$type = bp_code_snippets_single_code($bp->action_variables[1],0);
	if ( $bp->current_action == 'snippets' && $bp->action_variables[0]=="single") {
        wp_enqueue_script( 'shCore', BP_CS_PLUGIN_URL . '/js/highlighter/shCore.js' );
		wp_enqueue_script( 'shBrushPhp', BP_CS_PLUGIN_URL . '/js/highlighter/'.bp_code_snippets_load_post_js($type).'.js' );
		wp_enqueue_style('shCore', BP_CS_PLUGIN_URL . '/css/shCore.css');
		wp_enqueue_style('shTheme', BP_CS_PLUGIN_URL . '/css/theme/'.$theme_activated);
	}
	if ($bp->current_action == 'snippets'){
		wp_enqueue_style('code_snippets_style', BP_CS_PLUGIN_URL . '/css/bp-cs.css');
	}
	if(bp_is_group_forum() || $bp->current_component == "forums"){
		wp_enqueue_style('thickbox');
		wp_enqueue_script('jquery');
		wp_enqueue_script('thickbox');
		wp_enqueue_script( 'shCore', BP_CS_PLUGIN_URL . '/js/highlighter/shCore.js' );
		wp_enqueue_style('shCore', BP_CS_PLUGIN_URL . '/css/shCore.css');
		wp_enqueue_style('shTheme', BP_CS_PLUGIN_URL . '/css/theme/'.$theme_activated);
	}
}

add_action( 'init', 'bp_code_snippets_add_js', 1 );


/**
* bp_code_snippets_add_admin_menu
* Add a submenu to buddypress to edit code snippets settings.
* 
*/
function bp_code_snippets_add_admin_menu() {
	global $bp;

	if ( !$bp->loggedin_user->is_site_admin )
		return false;

	require ( dirname( __FILE__ ) . '/bp_snippets_manager_admin.php' );
	
	add_submenu_page( 'bp-general-settings', __( 'Code Snippets Manager', 'bp-code-snippets' ), __( 'Code Snippets Manager', 'bp-code-snippets' ), 'manage_options', 'bp-cs-admin', 'bp_snippets_manager_admin' );
}
add_action( 'admin_menu', 'bp_code_snippets_add_admin_menu',14 );


/**
* bp_code_snippets_activate
* Installs DBs and set default options
* 
*/
function bp_code_snippets_activate() {
	global $wpdb;

	if ( !empty($wpdb->charset) )
		$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";

	$sql[] = "CREATE TABLE {$wpdb->base_prefix}code_snippets (
	          id_cs int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
	  		  id_group int(10) NOT NULL,
	  		  id_user int(10) NOT NULL,
	  		  date_cs datetime NOT NULL,
	  		  snippet_title varchar(200) NOT NULL,
	  	      snippet_type varchar(20) NOT NULL,
	  		  snippet_purpose text NOT NULL,
	  		  snippet_content text NOT NULL,
	  		  cs_comment_count int(10) NOT NULL
	          ){$charset_collate};";
	
	$sql[] = "CREATE TABLE {$wpdb->base_prefix}code_snippets_comments (
		   	  id_cs_comment int(10) NOT NULL AUTO_INCREMENT PRIMARY KEY,
		  	  cs_id int(10) NOT NULL,
		   	  user_id int(10) NOT NULL,
		  	  date_comment datetime NOT NULL,
		  	  comment_content text NOT NULL
			  ){$charset_collate};";
	

	require_once( ABSPATH . 'wp-admin/upgrade-functions.php' );
	
	//if first install
	if(!get_option('bp-code-snippets-version')){
		dbDelta($sql);
		update_option( 'bp-code-snippets-version', BP_CS_VERSION );
		update_option( 'cs-enable', 1 );
		update_option( 'cs-ma-enable', 1 );
		update_option( 'cs-setting-theme', 'shThemeMidnight.css' );
	}
	//if upgrade
	elseif(get_option('bp-code-snippets-version')!=BP_CS_VERSION){
		update_option( 'bp-code-snippets-version', BP_CS_VERSION );
		update_option( 'cs-ma-enable', 1 );
		update_option( 'cs-homenav-enable', 1 );
	}
}
register_activation_hook( __FILE__, 'bp_code_snippets_activate' );
?>