<?php
/**
* Adding a button to post in order to attach a snippet...
*/
add_action('media_buttons', 'bp_code_snippets_add_media_button', 20);


function bp_code_snippets_add_media_button() {
	$url = BP_CS_PLUGIN_URL.'/bp-cs-snippet-selector.php?tab=add&TB_iframe=true&amp;height=500&amp;width=640';
	if (is_ssl()) $url = str_replace( 'http://', 'https://',  $url );
	echo '<a href="'.$url.'" class="thickbox" title="'.__('Add Snippet','bp-code-snippets').'"><img src="'.BP_CS_PLUGIN_URL.'/images/snippet_add.png" alt="'.__('Add Snippet','bp-code-snippets').'" width="16px" height="16px"></a>';
}

add_filter('the_content', 'bp_code_snippets_the_content',1);

function bp_code_snippets_the_content($content){
	$array_type_snippet=array();
	preg_match_all("/\[snippet id\=\"([0-9]+)/", $content, $matches, PREG_SET_ORDER);
	if($matches && is_single()){
		
		foreach($matches as $snippet){
			$type_snippet = bp_code_snippets_single_code($snippet[1],0);
			if(!in_array($type_snippet, $array_type_snippet)){
				$array_type_snippet[]=$type_snippet;
			}
		}
		$theme_activated = get_blog_option('1', 'cs-setting-theme');
		$content_before="<link rel='stylesheet' href='".BP_CS_PLUGIN_URL."/css/shCore.css' type='text/css' media='screen' />";
		$content_before.="<link rel='stylesheet' href='".BP_CS_PLUGIN_URL."/css/theme/".$theme_activated."' type='text/css' media='screen' />";
		$content_before.= "<script type='text/javascript' src='".BP_CS_PLUGIN_URL."/js/highlighter/shCore.js'></script>";
		foreach($array_type_snippet as $type){
			$content_before.= "<script type='text/javascript' src='".BP_CS_PLUGIN_URL."/js/highlighter/".bp_code_snippets_load_post_js($type).".js'></script>";
		}
		$content_after ='<script type="text/javascript">SyntaxHighlighter.all()</script>';
		return $content_before.$content.$content_after;
	}
	else return $content;
}

function bp_code_snippets_shortcode_handler($atts) {
	global $post;
	$siteurl = get_blog_option('1', 'siteurl');
	extract(shortcode_atts(array('id' => '0'), $atts));
	$snippet = bp_code_snippets_single_code($id,1);
	$user_info = get_userdata($snippet->id_user);
	if(is_single()){
		$group_info = bp_code_snippet_get_infos_goup($snippet->id_group);
		$snippet_permalink = '<a href="'.$siteurl.'/'.BP_GROUPS_SLUG.'/'.$group_info->slug.'/'.BP_CS_SLUG.'/single/'.$snippet->id_cs.'/" title="'. sprintf( __( 'See it in %s group ', 'bp-code-snippets'), $group_info->name ) .'">'.$group_info->name.'</a>';
		
		$snippet_content = '<a name="snippet_'.$id.'"></a><div class="code_in_content"><pre class="brush: '.$snippet->snippet_type.'">'.stripslashes($snippet->snippet_content).'</pre></div>';
		$snippet_content .='<div class="snippet_author"><a href="'.$siteurl.'/'.BP_MEMBERS_SLUG.'/'.$user_info->user_nicename.'" title="'.$user_info->user_nicename.'" rel="nofollow">'. bp_core_fetch_avatar('item_id=' . $snippet->id_user . '&type=full&width=24&height=24' ).'</a>'.__('Originally posted by', 'bp-code-snippets').' <a href="'.$siteurl.'/'.BP_MEMBERS_SLUG.'/'.$user_info->user_nicename.'" title="'.$user_info->user_nicename.'" rel="nofollow">'.$user_info->user_nicename.'</a> <i>'.sprintf( __( ' in %s group', 'bp-code-snippets' ), $snippet_permalink ).'</i></div>';
	}
	else{
		$snippet_link = get_permalink($post->ID);
		$snippet_link.='#snippet_'.$id;
		$snippet_content = '<a href="'.$snippet_link.'" title="'.__('Open Snippet', 'bp-code-snippets').'">'.stripslashes($snippet->snippet_title).'</a><br/>';
	}
	return $snippet_content;
}
add_shortcode('snippet', 'bp_code_snippets_shortcode_handler');
?>